Articles of return status

¿Devuelve un código de salida sin matar la terminal de la persona que llama?

Estoy teniendo dificultades para get el valor de retorno de un script. El script que me está second.sh problemas es second.sh continuación. Pero hay una interacción presente con un script llamado first.sh , y esa interacción parece ser la fuente del problema. El primer script es un script de testing e impulsa el segundo script. […]

Registre la salida del shell ssh y conserve el estado de salida

Tengo un script para ejecutar en el server remoto ( server-2 ) a través de ssh desde el server-1 y tengo que escribir ese resultado en un file de logging llamado file.log en server-1 . Estoy intentando esto: sc.sh echo 'testing' cp $HOME/dir1/file1 $HOME/dir2 Ahora, ejecutando el sc.sh través de ssh: sshpass -p 'psswd' ssh […]

captura el código de salida y la salida de un command

Hay preguntas similares, pero la mía es un poco diferente. O eso creo. Lo que me gustaría hacer es: 1.sh : #!/usr/bin/env bash set -eu r=0 a=$(./2.sh || r=$?) echo "$a" echo "$r" 2.sh : #!/usr/bin/env bash echo output exit 2 Pero produce: $ ./1.sh output 0 # I'd like to have `2` here Como […]

¿Un script de inicio siempre devuelve un código de salida correcto cuando se ejecuta el estado?

Intento escribir un script cron job que compruebe si mis services se están ejecutando y reinícielos si no lo están, así que no tengo que hacerlo manualmente. Ahora, he buscado en línea cómo verificar el estado de un service en un script bash, y he encontrado básicamente lo siguiente, con algunas variaciones: ps auxw | […]

¿Por qué las asignaciones variables de bash afectan el último código de salida $? y dónde está esto documentado?

Me sorprendió descubrir que establecer una variable de entorno modificó la última variable de código $? : $ false $ echo $? 1 $ false $ FOO=BAR $ echo $? 0 $ El manual bash solo dice esto sobre $? : ($?) Se expande al estado de salida de la tubería de primer plano ejecutada […]

Obtenga un resultado específico de la function

¿Hay alguna manera de devolver un valor específico en una function de eco? return me permite devolver un estado de salida para la function. Necesito devolver una estructura de datos más sofisticada, como una matriz o una cadena. Por lo general, necesitaría repetir el valor que quiero que me devuelvan. Pero, ¿qué pasa si necesito […]

Acceda al código de retorno del último command en AWK

El command no encontrado debe producir el código de retorno 127 : $ foo; echo $? bash: foo: command not found… 127 Traté de asignar $? a variable rc y luego imprimirlo, pero RC siempre es 0 . $ foo | awk -v rc="$?" 'BEGIN{print rc}' 0 bash: foo: command not found… Descubrió que imprimirá […]

¿Cómo get el estado de salida de un command en particular en una tubería?

Estoy ejecutando este ciclo while en un script para tomar mysqldump y comprimirlo, pero quiero exit del script si la table no existe. Debajo está lo que he intentado. while read TABLES; do sudo mysqldump $DB $TABLES | gzip -f > $DB.$TABLES.sql.gz if [ $? != 0 ]; then echo "mysqldump Query executed with error […]

Desde un script de shell, ejecuta otro con arguments y obtén su código de retorno

En una CPU dual de i686 / 32 bits, con una nueva installation de Debian Stretch, instalé Octave 4.2.1 y ./mytest luego de proporcionarle los privilegios de ejecución: #!/bin/bash ./mytest.m donde test.m lee #!/usr/bin/octave exit(0) Dado los dos scripts almacenados en ~/tmp , mytest #!/bin/bash if $1/mytest.m "$2"; then echo "good" else echo "bad" fi […]

Pasar por el código de estado de salida después de usar ||

Quiero escribir un alias que sea algo así como: alias baz="false || echo bar" (En realidad no es false , es un command que puede fallar). Sin embargo, quiero pasar el código de estado fallido al próximo invocador. En otras palabras, aquí está el comportamiento actual: $ false; echo $? 1 $ false || echo […]